TIFFDescriptorImpl (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.model.impl

## Class TIFFDescriptorImpl

- java.lang.Object
- - tv.amwa.maj.model.impl.InterchangeObjectImpl
  - - tv.amwa.maj.model.impl.EssenceDescriptorImpl
    - - tv.amwa.maj.model.impl.AAFFileDescriptorImpl
      - - tv.amwa.maj.model.impl.TIFFDescriptorImpl

- All Implemented Interfaces:
    Serializable, Cloneable, QAAFFileDescriptor, MediaEntity, MetadataObject, AAFFileDescriptor, EssenceDescriptor, InterchangeObject, TIFFDescriptor

      @MediaClass(uuid1=218169601,
                  uuid2=257,
                  uuid3=11008,
                  uuid4={6,14,43,52,2,6,1,1},
                  definedName="TIFFDescriptor",
                  description="The TIFFDescriptor class specifies that a File SourcePackage is associated with video essence formatted according to the TIFF specification.",
                  symbol="TIFFDescriptor")
      public class TIFFDescriptorImpl
      extends AAFFileDescriptorImpl
      implements TIFFDescriptor, Serializable, Cloneable

  Implements the description of a file of video essence formatted according to the Tagged Image File Format (TIFF) specification.

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `ObjectClassPropertyID`

    - ### Fields inherited from interface tv.amwa.maj.model.TIFFDescriptor

      `LEADINGLINES_DEFAULT, TRAILINGLINES_DEFAULT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TIFFDescriptorImpl()`
    `TIFFDescriptorImpl(ContainerDefinition containerFormat, boolean isUniform, boolean isContiguous, byte[] summary)` Creates and initializes a new TIFF descritpor, which specifies that a `file source package` is associated with video essence formatted according to the TIFF specification.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `TIFFDescriptor` | `clone()` Create a cloned copy of this interchange object.
    `boolean` | `getIsContiguous()` Returns `true` if essence data is stored in contiguous bytes for the TIFF data described by this TIFF descriptor; otherwise `false.`
    `boolean` | `getIsUniform()` Returns `true` if the TIFF data described by this TIFF descriptor has the same number of rows per strip throughout; otherwise `false`.
    `int` | `getJPEGTableID()` Returns the JPEG table code property of this TIFF descriptor, which specifies the registered JPEG table code.
    `int` | `getLeadingLines()` Returns the number of leading lines of the TIFF descriptor, which specifies the number of leading lines to be thrown away when viewing the TIFF data.
    `int` | `getSummaryBufferSize()` Returns the size of the buffer required by the `TIFFDescriptor.getTIFFSummary()` method.
    `byte[]` | `getTIFFSummary()` Returns the copy of the TIFF IFD file information of this TIFF descriptor, without the sample data.
    `int` | `getTrailingLines()` Returns the number of trailing lines of this TIFF descriptor, which specifies the number of trailing lines to be thrown away when viewing the TIFF data.
    `static boolean` | `initializeIsContiguous()`
    `static boolean` | `initializeIsUniform()`
    `static byte[]` | `initializeTIFFSummary()`
    `void` | `setIsContiguous(boolean isContiguous)` Sets whether essence data is stored in contiguous bytes for the TIFF data described by this TIFF descriptor.
    `void` | `setIsUniform(boolean isUniform)` Sets whether the TIFF data described by this TIFF descriptor has the same number of rows per strip throughout.
    `void` | `setJPEGTableID(Integer jpegTableID)` Sets the JPEG table code property of this TIFF descriptor, which specifies the registered JPEG table code.
    `void` | `setLeadingLines(Integer leadingLines)` Sets the number of leading lines of this TIFF descriptor, which specifies the number of leading lines to be thrown away when viewing the TIFF data.
    `void` | `setTIFFSummary(byte[] tiffSummary)` Sets the copy of the TIFF IFD file information of this TIFF descriptor, without the sample data.
    `void` | `setTrailingLines(Integer trailingLines)` Sets the number of trailing lines of this TIFF descriptor, which specifies the number of trailing lines to be thrown away when viewing the TIFF data.

    - ### Methods inherited from class tv.amwa.maj.model.impl.AAFFileDescriptorImpl

      `describesStaticEssence, getCodec, getContainerFormat, getEssenceLength, getLinkedTrackID, getSampleRate, getSampleRateString, getTwentyFourBitAudio, initializeEssenceLength, initializeSampleRate, setCodec, setContainerFormat, setDescribesStaticEssence, setDescribesTimeVaryingEssence, setEssenceLength, setEssenceLengthFromStream, setLinkedTrackID, setSampleRate, setSampleRateFromStream, setSampleRateString, setTwentyFourBitAudio`

    - ### Methods inherited from class tv.amwa.maj.model.impl.EssenceDescriptorImpl

      `appendLocator, appendSubDescriptor, clearLocators, clearSubDescriptors, countLocators, countSubDescriptors, getComment, getLocatorAt, getLocators, getSubDescriptorAt, getSubDescriptors, insertLocatorAt, insertSubDescriptorAt, prependLocator, prependSubDescriptor, removeLocatorAt, removeSubDescriptorAt`

    - ### Methods inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `addApplicationPlugin, appendXMLChildren, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getLinkedGenerationIDString, getObjectClass, getPersistentID, getPersistentIndex, hashCode, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setLinkedGenerationIDString, setObjectClass, setPersistentID, setPersistentIndex, toString`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tv.amwa.maj.model.AAFFileDescriptor

      `getCodec, getContainerFormat, getEssenceLength, getLinkedTrackID, getSampleRate, setCodec, setContainerFormat, setEssenceLength, setLinkedTrackID, setSampleRate`

    - ### Methods inherited from interface tv.amwa.maj.model.EssenceDescriptor

      `appendLocator, appendSubDescriptor, clearLocators, countLocators, countSubDescriptors, getLocatorAt, getLocators, getSubDescriptorAt, getSubDescriptors, insertLocatorAt, insertSubDescriptorAt, prependLocator, prependSubDescriptor, removeLocatorAt, removeSubDescriptorAt`

    - ### Methods inherited from interface tv.amwa.maj.model.InterchangeObject

      `addApplicationPlugin, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getObjectClass, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setObjectClass, toString`

    - ### Methods inherited from interface tv.amwa.maj.industry.MediaEntity

      `getPersistentID, setPersistentIndex`

- - ### Constructor Detail

    - #### TIFFDescriptorImpl

          public TIFFDescriptorImpl()

    - #### TIFFDescriptorImpl

          public TIFFDescriptorImpl(ContainerDefinition containerFormat,
                                    @Bool
                                    boolean isUniform,
                                    @Bool
                                    boolean isContiguous,
                                    @DataValue
                                    byte[] summary)
                             throws NullPointerException

      Creates and initializes a new TIFF descritpor, which specifies that a `file source package` is associated with video essence formatted according to the TIFF specification.

      Parameters:
        `containerFormat` - Container format of the TIFF data.
        `isUniform` - Does the data have the same number of rows per strip throughout?
        `isContiguous` - Is the data stored in contiguous bytes?
        `summary` - A copy of the TIFF IFD, without the sample data.
      Throws:
        `NullPointerException` - The container format and/or summary arguments are `null` and both are required.

  - ### Method Detail

    - #### getIsContiguous

          @MediaProperty(uuid1=101188097,
                         uuid2=0,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,1},
                         definedName="IsContiguous",
                         typeName="Boolean",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=14082,
                         symbol="IsContiguous")
          public boolean getIsContiguous()

      Description copied from interface: `TIFFDescriptor`

      Returns `true` if essence data is stored in contiguous bytes for the TIFF data described by this TIFF descriptor; otherwise `false.`

      Specified by:
        `getIsContiguous` in interface `TIFFDescriptor`
      Returns:
        Is the TIFF data represented by the TIFF descriptor stored in contiguous bytes?

    - #### setIsContiguous

          @MediaPropertySetter(value="IsContiguous")
          public void setIsContiguous(boolean isContiguous)

      Description copied from interface: `TIFFDescriptor`

      Sets whether essence data is stored in contiguous bytes for the TIFF data described by this TIFF descriptor. Set to `true` if the data is contiguous; otherwise `false`.

      Specified by:
        `setIsContiguous` in interface `TIFFDescriptor`
      Parameters:
        `isContiguous` - Is the TIFF data represented by the TIFF descriptor stored in contiguous bytes?

    - #### initializeIsContiguous

          public static final boolean initializeIsContiguous()

    - #### getIsUniform

          @MediaProperty(uuid1=84017411,
                         uuid2=257,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="IsUniform",
                         typeName="Boolean",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=14081,
                         symbol="IsUniform")
          public boolean getIsUniform()

      Description copied from interface: `TIFFDescriptor`

      Returns `true` if the TIFF data described by this TIFF descriptor has the same number of rows per strip throughout; otherwise `false`.

      Specified by:
        `getIsUniform` in interface `TIFFDescriptor`
      Returns:
        Does the TIFF data represented by the TIFF descriptor have the same number of rows per strip throughout?

    - #### setIsUniform

          @MediaPropertySetter(value="IsUniform")
          public void setIsUniform(boolean isUniform)

      Description copied from interface: `TIFFDescriptor`

      Sets whether the TIFF data described by this TIFF descriptor has the same number of rows per strip throughout. Set to `true` if it does; otherwise `false`.

      Specified by:
        `setIsUniform` in interface `TIFFDescriptor`
      Parameters:
        `isUniform` - Does the TIFF data described by this TIFF descriptor have the same number of rows per strip throughout?

    - #### initializeIsUniform

          public static final boolean initializeIsUniform()

    - #### getJPEGTableID

          @MediaProperty(uuid1=84017411,
                         uuid2=258,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="JPEGTableID",
                         typeName="JPEGTableIDType",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=14085,
                         symbol="JPEGTableID")
          public int getJPEGTableID()
                                                                                                                                                                                                                                                                                                                                                                                  throws PropertyNotPresentException

      Description copied from interface: `TIFFDescriptor`

      Returns the JPEG table code property of this TIFF descriptor, which specifies the registered JPEG table code. This is an optional property that, when omitted, indicate that the described image data uses a table that is not registered.

      Specified by:
        `getJPEGTableID` in interface `TIFFDescriptor`
      Returns:
        JPEG table code property of this TIFF descriptor.
      Throws:
        `PropertyNotPresentException` - The optional JPEG table id property is not present in this TIFF descriptor.

    - #### setJPEGTableID

          @MediaPropertySetter(value="JPEGTableID")
          public void setJPEGTableID(Integer jpegTableID)

      Description copied from interface: `TIFFDescriptor`

      Sets the JPEG table code property of this TIFF descriptor, which specifies the registered JPEG table code. Set this optional property to `null` to omit it and indicate that the described image data uses a table that is not registered.

      Specified by:
        `setJPEGTableID` in interface `TIFFDescriptor`
      Parameters:
        `jpegTableID` - JPEG table code property of tis TIFF descriptor.

    - #### getLeadingLines

          @MediaProperty(uuid1=67175170,
                         uuid2=768,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,1},
                         definedName="LeadingLines",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=14083,
                         symbol="LeadingLines")
          public int getLeadingLines()

      Description copied from interface: `TIFFDescriptor`

      Returns the number of leading lines of the TIFF descriptor, which specifies the number of leading lines to be thrown away when viewing the TIFF data.

      If this optional property is omitted, its default value of 0 will be returned.

      Specified by:
        `getLeadingLines` in interface `TIFFDescriptor`
      Returns:
        Number of leading lines of the TIFF descriptor.
      See Also:
        `TIFFDescriptor.LEADINGLINES_DEFAULT`, `TIFFDescriptor.getTrailingLines()`

    - #### setLeadingLines

          @MediaPropertySetter(value="LeadingLines")
          public void setLeadingLines(Integer leadingLines)

      Description copied from interface: `TIFFDescriptor`

      Sets the number of leading lines of this TIFF descriptor, which specifies the number of leading lines to be thrown away when viewing the TIFF data.

      The optional property has a default value of 0. Set this optional property to `null` to omit it.

      Specified by:
        `setLeadingLines` in interface `TIFFDescriptor`
      Parameters:
        `leadingLines` - Number of leading lines of this TIFF descriptor.
      See Also:
        `TIFFDescriptor.LEADINGLINES_DEFAULT`, `TIFFDescriptor.setTrailingLines(Integer)`

    - #### getTIFFSummary

          @MediaProperty(uuid1=50529026,
                         uuid2=768,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="TIFFSummary",
                         aliases={"Summary","TIFFDescriptorSummary"},
                         typeName="DataValue",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=14086,
                         symbol="TIFFSummary")
          public byte[] getTIFFSummary()

      Description copied from interface: `TIFFDescriptor`

      Returns the copy of the TIFF IFD file information of this TIFF descriptor, without the sample data.

      Specified by:
        `getTIFFSummary` in interface `TIFFDescriptor`
      Returns:
        Copy of the TIFF IFD file information of the TIFF descriptor.

    - #### setTIFFSummary

          @MediaPropertySetter(value="TIFFSummary")
          public void setTIFFSummary(byte[] tiffSummary)
                                                                        throws NullPointerException

      Description copied from interface: `TIFFDescriptor`

      Sets the copy of the TIFF IFD file information of this TIFF descriptor, without the sample data.

      Specified by:
        `setTIFFSummary` in interface `TIFFDescriptor`
      Parameters:
        `tiffSummary` - Sets the TIFF IFD file information of this TIFF descriptor.
      Throws:
        `NullPointerException` - The given TIFF IFD data is `null`.

    - #### getSummaryBufferSize

          public int getSummaryBufferSize()

      Description copied from interface: `TIFFDescriptor`

      Returns the size of the buffer required by the `TIFFDescriptor.getTIFFSummary()` method.

      Specified by:
        `getSummaryBufferSize` in interface `TIFFDescriptor`
      Returns:
        Size of the buffer required by the `TIFFDescriptor.getTIFFSummary()` method.

    - #### initializeTIFFSummary

          public static final byte[] initializeTIFFSummary()

    - #### getTrailingLines

          @MediaProperty(uuid1=67175170,
                         uuid2=1024,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,1},
                         definedName="TrailingLines",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=14084,
                         symbol="TrailingLines")
          public int getTrailingLines()

      Description copied from interface: `TIFFDescriptor`

      Returns the number of trailing lines of this TIFF descriptor, which specifies the number of trailing lines to be thrown away when viewing the TIFF data.

      If this optional property is omitted, its default value of 0 will be returned.

      Specified by:
        `getTrailingLines` in interface `TIFFDescriptor`
      Returns:
        Trailing lines of this TIFF descriptor.
      See Also:
        `TIFFDescriptor.TRAILINGLINES_DEFAULT`, `TIFFDescriptor.getTrailingLines()`

    - #### setTrailingLines

          @MediaPropertySetter(value="TrailingLines")
          public void setTrailingLines(Integer trailingLines)

      Description copied from interface: `TIFFDescriptor`

      Sets the number of trailing lines of this TIFF descriptor, which specifies the number of trailing lines to be thrown away when viewing the TIFF data.

      This optional property has a default value of 0. Set this optional property to `null` to omit it.

      Specified by:
        `setTrailingLines` in interface `TIFFDescriptor`
      Parameters:
        `trailingLines` - Trailing lines of this TIFF descriptor.
      See Also:
        `TIFFDescriptor.TRAILINGLINES_DEFAULT`, `TIFFDescriptor.setLeadingLines(Integer)`

    - #### clone

          public TIFFDescriptor clone()

      Description copied from interface: `InterchangeObject`

      Create a cloned copy of this interchange object.

      Specified by:
        `clone` in interface `MediaEntity`
      Specified by:
        `clone` in interface `AAFFileDescriptor`
      Specified by:
        `clone` in interface `EssenceDescriptor`
      Specified by:
        `clone` in interface `InterchangeObject`
      Specified by:
        `clone` in interface `TIFFDescriptor`
      Overrides:
        `clone` in class `AAFFileDescriptorImpl`
      Returns:
        Cloned copy of this interchange object.

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.